
/****************************************************************************
*
*ļDSP28_PieVect.c
*
*  ܣ2812жгʼ
*
*  : likyo from hellodsp
*
****************************************************************************/

#include "DSP28_Device.h"

const struct PIE_VECT_TABLE PieVectTableInit = {

      PIE_RESERVED,  // Ŀռ
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   
      PIE_RESERVED,   


      // ж
      INT13_ISR,     // XINT13CPUʱ1ж
      INT14_ISR,     // CPUʱ2ж
      DATALOG_ISR,   // CPUݼ¼ж
      RTOSINT_ISR,   // CPUʵʱOSж
      EMUINT_ISR,    // CPUж
      NMI_ISR,       // ⲿж
      ILLEGAL_ISR,   // Ƿ
      USER0_ISR,     // ûж0
      USER1_ISR,     // ûж1
      USER2_ISR,     // ûж2
      USER3_ISR,     // ûж3
      USER4_ISR,     // ûж4
      USER5_ISR,     // ûж5
      USER6_ISR,     // ûж6
      USER7_ISR,     // ûж7
      USER8_ISR,     // ûж8
      USER9_ISR,     // ûж9
      USER10_ISR,    // ûж10
      USER11_ISR,    // ûж11

      // PIE 1
      PDPINTA_ISR,   // EV-AĹж
      PDPINTB_ISR,   // EV-BĹж
      rsvd_ISR,      // 
      XINT1_ISR,     // ⲿӿڣXINT1ж   
      XINT2_ISR,     // ⲿӿڣXINT2ж
      ADCINT_ISR,    // ADCж
      TINT0_ISR,     // CPUʱ0ж
      WAKEINT_ISR,   // WDж

      // PIE 2
      CMP1INT_ISR,   // ȽϵԪ1Ƚж
      CMP2INT_ISR,   // ȽϵԪ2Ƚж
      CMP3INT_ISR,   // ȽϵԪ3Ƚж
      T1PINT_ISR,    // ͨöʱ1ж
      T1CINT_ISR,    // ͨöʱ1Ƚж
      T1UFINT_ISR,   // ͨöʱ1ж
      T1OFINT_ISR,   // ͨöʱ1ж
      rsvd_ISR,      // 
      
      // PIE 3
      T2PINT_ISR,    // ͨöʱ2ж
      T2CINT_ISR,    // ͨöʱ2Ƚж
      T2UFINT_ISR,   // ͨöʱ2ж
      T2OFINT_ISR,   // ͨöʱ2ж
      CAPINT1_ISR,   // Ԫ1ж
      CAPINT2_ISR,   // Ԫ2ж
      CAPINT3_ISR,   // Ԫ3ж
      rsvd_ISR,
      
      // PIE 4
      CMP4INT_ISR,   // ȽϵԪ4Ƚж
      CMP5INT_ISR,   // ȽϵԪ5Ƚж
      CMP6INT_ISR,   // ȽϵԪ6Ƚж
      T3PINT_ISR,    // ͨöʱ3ж
      T3CINT_ISR,    // ͨöʱ3Ƚж
      T3UFINT_ISR,   // ͨöʱ3ж
      T3OFINT_ISR,   // ͨöʱ3ж
      rsvd_ISR,      // 
     
      // PIE 5
      T4PINT_ISR,    // ͨöʱ4ж
      T4CINT_ISR,    // ͨöʱ4Ƚж
      T4UFINT_ISR,   // ͨöʱ4ж
      T4OFINT_ISR,   // ͨöʱ4ж
      CAPINT4_ISR,   // Ԫ4ж
      CAPINT5_ISR,   // Ԫ5ж
      CAPINT6_ISR,   // Ԫ6ж
      rsvd_ISR,      //   

      // PIE 6
      SPIRXINTA_ISR, // SPI-Aж
      SPITXINTA_ISR, // SPI-Aж
      rsvd_ISR,      // 
      rsvd_ISR,
      MRINTA_ISR,    // McBSP-Aж
      MXINTA_ISR,    // McBSP-Aж
      rsvd_ISR,      //
      rsvd_ISR,
      
      // PIE 7
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   

      // PIE 8
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      
      // PIE 9    
      SCIRXINTA_ISR, // SCI-Aж
      SCITXINTA_ISR, // SCI-Aж
      SCIRXINTB_ISR, // SCI-Bж
      SCITXINTB_ISR, // SCI-Bж
      ECAN0INTA_ISR, // eCAN0ж
      ECAN1INTA_ISR, // eCAN1ж
      rsvd_ISR,   
      rsvd_ISR,   
      
      // PIE 10
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
            
      // PIE 11
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   

      // PIE 12
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
      rsvd_ISR,   
};


/****************************************************************************
*
*    ƣInitPieVectTable()
*
*    ܣúPIEжгʼϵִ
*
*ڲ
*
*ڲ
*
****************************************************************************/

void InitPieVectTable(void)
{
	int16	i;
	Uint32 *Source = (void *) &PieVectTableInit;
	Uint32 *Dest = (void *) &PieVectTable;
		
	EALLOW;	
	for(i=0; i < 128; i++)
		*Dest++ = *Source++;	
	EDIS;

	// ʹPIE
	PieCtrl.PIECRTL.bit.ENPIE = 1;	
			
}

//===========================================================================
// No more.
//===========================================================================
